###############################################################################
#
# WikiؤΥݤեåץ饰
#
###############################################################################
package plugin::core::AccessDeny;
use strict;
#==============================================================================
# 󥹥ȥ饯
#==============================================================================
sub new {
	my $class = shift;
	my $self = {};
	return bless $self,$class;
}
#==============================================================================
# եå᥽å
#==============================================================================
sub hook {
	my $self = shift;
	my $wiki = shift;
	my $name = shift;
	my $config_dir = shift;
	my $cgi  = $wiki->get_CGI();
	
	$config_dir = $wiki->config('config_dir') if(!defined($config_dir));
	
	my $rule = &Util::load_config_text(undef,$config_dir.'/access_deny_rules.dat');
	foreach my $line (split(/\n/, $rule)){
		chomp($line);
		if($line eq 'TAKE_OVER_FROM_PARENT'){
			$self->{wiki_depth_count} = 0 if(!defined($self->{wiki_depth_count}));
			# ƵƽФνΤ߽
			if ($self->{wiki_depth_count} == 0) {
				$self->{wiki_depth} = $wiki->_get_wiki_depth();
			}
			# wiki_depth βƵƽ
			if ($self->{wiki_depth_count} < $self->{wiki_depth}) {
				$self->{wiki_depth_count}++;
				$config_dir .= '/..';
				$self->hook($wiki,$name,$config_dir);
			}
			return;
		}
		$self->{write_log} = 1 if($line eq 'WRITE_LOG');
		$self->{ALLOW_ACCESS_FONTPAGE} = 1 if($line eq 'ALLOW_ACCESS_FONTPAGE');
		$self->{RULE_NO_USERAGENT} = 1 if($line eq 'RULE_NO_USERAGENT');
	}
	
	return if ($self->{ALLOW_ACCESS_FONTPAGE}==1 && ALLOW_ACCESS_FONTPAGE($wiki));
	
	my $ip = $ENV{'REMOTE_ADDR'};
	my $ip_list = &Util::load_config_text(undef,$config_dir.'/access_deny_ip.dat');
	foreach my $line (split(/\n/, $ip_list)){
		my ($from, $to) = split(/-/, $line);
		$to = $from if($to eq '');
		unless(&ip_check($ip, Util::trim($from), Util::trim($to))){
			$self->die_on_access_deny($wiki);
		}
	}
	
	my $ua = $ENV{'HTTP_USER_AGENT'};
	# USER-AGENTʤξ¸ݤ롼
	if (defined($self->{RULE_NO_USERAGENT}) && $ua eq '') {
		$self->die_on_access_deny($wiki);
	}
	# USER-AGENTݥꥹȥå
	my $ua_list = &Util::load_config_text(undef,$config_dir.'/access_deny_ua.dat');
	foreach my $line (split(/\n/, $ua_list)){
		chomp($line);
		if(index($ua,$line)!=-1){
			$self->die_on_access_deny($wiki);
		}
	}
}

#==============================================================================
# 顼ڡɽ
#==============================================================================
sub die_on_access_deny {
	my $self = shift;
	my $wiki = shift;
	my $cgi  = $wiki->get_CGI();
	
	# ݥν񤭽Ф
	&write_log($wiki) if (defined($self->{write_log}));
	
	# ƥץ졼Ȥɤ߹
	my $tmpl = HTML::Template->new(filename=>$wiki->config('tmpl_dir')."/access_deny.tmpl",
	                               die_on_bad_params => 0);
	$tmpl->param(
		ACTION => defined($cgi->param('action'))?$cgi->param('action'):0,
		PAGE   => defined($cgi->param('page'))?$cgi->param('page'):$wiki->config('frontpage')
	);
	
	# 顼ڡɽ
	print "Content-Type: text/html\n\n";
	print $tmpl->output();
	die 'safe_die';
}

#==============================================================================
# ݥεϿ
#==============================================================================
sub write_log {
	my $wiki = shift;
	
	my $ip  = $ENV{"REMOTE_ADDR"};
	my $ref = $ENV{"HTTP_REFERER"};
	my $uri = $ENV{"REQUEST_URI"};
	my $ua  = $ENV{"HTTP_USER_AGENT"};
	if(!defined($ip)  || $ip  eq ""){ $ip  = "-"; }
	if(!defined($ref) || $ref eq ""){ $ref = "-"; }
	if(!defined($ua)  || $ua  eq ""){ $ua  = "-"; }
	
	open(LOG,">>".$wiki->config('log_dir')."/access_deny.log") or die $!;
	print LOG &log_date()." $ip $uri $ref $ua\n";
	close(LOG);
}

#===============================================================================
# դեޥåȡʥѡ
#===============================================================================
sub log_date {
	my ($sec, $min, $hour, $mday, $mon, $year) = localtime(time());
	return sprintf("%04d/%02d/%02d %02d:%02d:%02d",
	               $year+1900,$mon+1,$mday,$hour,$min,$sec);
}

#==============================================================================
# IPɥ쥹Υå
#==============================================================================
sub ip_check {
	my $client = shift;
	my $from   = shift;
	my $to     = shift;
	
	my @client_dim = split(/\./, $client);
	my @from_dim   = split(/\./, $from);
	my @to_dim     = split(/\./, $to);
	
	foreach my $part (@client_dim){
		unless((shift @from_dim) <= $part && $part <= (shift @to_dim)){
			return 1;
		}
	}
	return 0;
}

#==============================================================================
# FrontPage ؤΥĤ뤫ɤ
#==============================================================================
sub ALLOW_ACCESS_FONTPAGE {
	my $wiki = shift;
	my $cgi  = $wiki->get_CGI();
	
	if ( !defined($cgi->param('action')) &&
	    ( !defined($cgi->param('page')) ||
	      $cgi->param('page') eq $wiki->config('frontpage')) ){
		return 1;
	}
	return 0;
}

1;

